import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.util.Random;

public class FormArmoredCar extends JFrame{
    private JButton buttonUp;
    private JButton buttonDown;
    private JButton buttonRight;
    private JButton buttonLeft;
    private JPanel mainPanel;
    private JPanel drawPanel;
    private JButton buttonCreate;
    private JLabel labelSpeed;
    private JLabel labelWeight;
    private JLabel labelColor;

    private DrawingArmoredCar armoredCar;

    public FormArmoredCar() {
        super("Бронированная машина");
        setBounds(100, 100, 700, 700);
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        addComponentListener(new ComponentAdapter() {
            public void componentResized(ComponentEvent componentEvent) {
                if (armoredCar != null) {
                    armoredCar.ChangeBorders(drawPanel.getWidth(), drawPanel.getHeight());
                    repaint();
                }
            }
        });

        labelSpeed.setText("Скорость: ");
        labelWeight.setText("Вес: ");
        labelColor.setText("Цвет: ");

        buttonCreate.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent actionEvent) {
                Random rnd = new Random();
                armoredCar = new DrawingArmoredCar(rnd.nextInt(100,300), rnd.nextInt(1000, 2000),
                        new Color(rnd.nextInt(256), rnd.nextInt(256), rnd.nextInt(256)));

                armoredCar.SetPosition(rnd.nextInt(10, 100), rnd.nextInt(10, 100),
                        drawPanel.getWidth(), drawPanel.getHeight());

                labelSpeed.setText("Скорость: " + armoredCar.getArmoredCar().getSpeed());
                labelWeight.setText("Вес: " + armoredCar.getArmoredCar().getWeight());
                labelColor.setText("Цвет: " + armoredCar.getArmoredCar().getBodyColor().getRGB());
            }
        });

        buttonUp.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent actionEvent) {
                if (armoredCar != null)
                    armoredCar.MoveTransport(Direction.Up);
                drawPanel.repaint();
            }
        });

        buttonDown.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent actionEvent) {
                if (armoredCar != null)
                    armoredCar.MoveTransport(Direction.Down);
                drawPanel.repaint();

            }
        });

        buttonLeft.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent actionEvent) {
                if (armoredCar != null)
                    armoredCar.MoveTransport(Direction.Left);
                drawPanel.repaint();
            }
        });

        buttonRight.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent actionEvent) {
                if (armoredCar != null)
                    armoredCar.MoveTransport(Direction.Right);
                drawPanel.repaint();
            }
        });

        setContentPane(mainPanel);
        setVisible(true);
    }

    private void createUIComponents() {
        drawPanel = new JPanel() {
            @Override
            public void paintComponent(Graphics g) {
                super.paintComponent(g);
                if (armoredCar != null) {
                    Graphics2D g2d = (Graphics2D) g;
                    armoredCar.DrawTransport(g2d);
                }
                super.repaint();
            }
        };
    }
}